git-fetch.shon commit Show peeled onion from upload-pack and server-info. (f6b42a8)
   1#!/bin/sh
   2#
   3. git-sh-setup || die "Not a git archive"
   4. git-parse-remote
   5_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
   6_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
   7
   8LF='
   9'
  10IFS="$LF"
  11
  12tags=
  13append=
  14force=
  15update_head_ok=
  16while case "$#" in 0) break ;; esac
  17do
  18        case "$1" in
  19        -a|--a|--ap|--app|--appe|--appen|--append)
  20                append=t
  21                ;;
  22        -f|--f|--fo|--for|--forc|--force)
  23                force=t
  24                ;;
  25        -t|--t|--ta|--tag|--tags)
  26                tags=t
  27                ;;
  28        -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
  29        --update-he|--update-hea|--update-head|--update-head-|\
  30        --update-head-o|--update-head-ok)
  31                update_head_ok=t
  32                ;;
  33        *)
  34                break
  35                ;;
  36        esac
  37        shift
  38done
  39
  40case "$#" in
  410)
  42        test -f "$GIT_DIR/branches/origin" ||
  43                test -f "$GIT_DIR/remotes/origin" ||
  44                        die "Where do you want to fetch from today?"
  45        set origin ;;
  46esac
  47
  48remote_nick="$1"
  49remote=$(get_remote_url "$@")
  50refs=
  51rref=
  52rsync_slurped_objects=
  53
  54if test "" = "$append"
  55then
  56        : >"$GIT_DIR/FETCH_HEAD"
  57fi
  58
  59append_fetch_head () {
  60    head_="$1"
  61    remote_="$2"
  62    remote_name_="$3"
  63    remote_nick_="$4"
  64    local_name_="$5"
  65    case "$6" in
  66    t) not_for_merge_='not-for-merge' ;;
  67    '') not_for_merge_= ;;
  68    esac
  69
  70    # remote-nick is the URL given on the command line (or a shorthand)
  71    # remote-name is the $GIT_DIR relative refs/ path we computed
  72    # for this refspec.
  73    case "$remote_name_" in
  74    HEAD)
  75        note_= ;;
  76    refs/heads/*)
  77        note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
  78        note_="branch '$note_' of " ;;
  79    refs/tags/*)
  80        note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
  81        note_="tag '$note_' of " ;;
  82    *)
  83        note_="$remote_name of " ;;
  84    esac
  85    remote_1_=$(expr "$remote_" : '\(.*\)\.git/*$') &&
  86        remote_="$remote_1_"
  87    note_="$note_$remote_"
  88
  89    # 2.6.11-tree tag would not be happy to be fed to resolve.
  90    if git-cat-file commit "$head_" >/dev/null 2>&1
  91    then
  92        headc_=$(git-rev-parse --verify "$head_^0") || exit
  93        echo "$headc_   $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
  94        echo >&2 "* committish: $head_"
  95        echo >&2 "  $note_"
  96    else
  97        echo "$head_    not-for-merge   $note_" >>"$GIT_DIR/FETCH_HEAD"
  98        echo >&2 "* non-commit: $head_"
  99        echo >&2 "  $note_"
 100    fi
 101    if test "$local_name_" != ""
 102    then
 103        # We are storing the head locally.  Make sure that it is
 104        # a fast forward (aka "reverse push").
 105        fast_forward_local "$local_name_" "$head_" "$note_"
 106    fi
 107}
 108
 109fast_forward_local () {
 110    mkdir -p "$(dirname "$GIT_DIR/$1")"
 111    case "$1" in
 112    refs/tags/*)
 113        # Tags need not be pointing at commits so there
 114        # is no way to guarantee "fast-forward" anyway.
 115        if test -f "$GIT_DIR/$1"
 116        then
 117                echo >&2 "* $1: updating with $3"
 118        else
 119                echo >&2 "* $1: storing $3"
 120        fi
 121        git-update-ref "$1" "$2" 
 122        ;;
 123
 124    refs/heads/*)
 125        # $1 is the ref being updated.
 126        # $2 is the new value for the ref.
 127        local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
 128        if test "$local"
 129        then
 130            # Require fast-forward.
 131            mb=$(git-merge-base "$local" "$2") &&
 132            case "$2,$mb" in
 133            $local,*)
 134                echo >&2 "* $1: same as $3"
 135                ;;
 136            *,$local)
 137                echo >&2 "* $1: fast forward to $3"
 138                git-update-ref "$1" "$2" "$local"
 139                ;;
 140            *)
 141                false
 142                ;;
 143            esac || {
 144                echo >&2 "* $1: does not fast forward to $3;"
 145                case ",$force,$single_force," in
 146                *,t,*)
 147                        echo >&2 "  forcing update."
 148                        git-update-ref "$1" "$2" "$local"
 149                        ;;
 150                *)
 151                        echo >&2 "  not updating."
 152                        ;;
 153                esac
 154            }
 155        else
 156            echo >&2 "* $1: storing $3"
 157            git-update-ref "$1" "$2"
 158        fi
 159        ;;
 160    esac
 161}
 162
 163case "$update_head_ok" in
 164'')
 165        orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 166        ;;
 167esac
 168
 169# If --tags (and later --heads or --all) is specified, then we are
 170# not talking about defaults stored in Pull: line of remotes or
 171# branches file, and just fetch those and refspecs explicitly given.
 172# Otherwise we do what we always did.
 173
 174reflist=$(get_remote_refs_for_fetch "$@")
 175if test "$tags"
 176then
 177        taglist=$(git-ls-remote --tags "$remote" |
 178                sed -e '
 179                        /\^{}$/d
 180                        s/^[^   ]*      //
 181                        s/.*/&:&/')
 182        if test "$#" -gt 1
 183        then
 184                # remote URL plus explicit refspecs; we need to merge them.
 185                reflist="$reflist$LF$taglist"
 186        else
 187                # No explicit refspecs; fetch tags only.
 188                reflist=$taglist
 189        fi
 190fi
 191
 192for ref in $reflist
 193do
 194    refs="$refs$LF$ref"
 195
 196    # These are relative path from $GIT_DIR, typically starting at refs/
 197    # but may be HEAD
 198    if expr "$ref" : '\.' >/dev/null
 199    then
 200        not_for_merge=t
 201        ref=$(expr "$ref" : '\.\(.*\)')
 202    else
 203        not_for_merge=
 204    fi
 205    if expr "$ref" : '\+' >/dev/null
 206    then
 207        single_force=t
 208        ref=$(expr "$ref" : '\+\(.*\)')
 209    else
 210        single_force=
 211    fi
 212    remote_name=$(expr "$ref" : '\([^:]*\):')
 213    local_name=$(expr "$ref" : '[^:]*:\(.*\)')
 214
 215    rref="$rref$LF$remote_name"
 216
 217    # There are transports that can fetch only one head at a time...
 218    case "$remote" in
 219    http://* | https://*)
 220        if [ -n "$GIT_SSL_NO_VERIFY" ]; then
 221            curl_extra_args="-k"
 222        fi
 223        remote_name_quoted=$(perl -e '
 224            my $u = $ARGV[0];
 225            $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
 226            print "$u";
 227        ' "$remote_name")
 228        head=$(curl -nsf $curl_extra_args "$remote/$remote_name_quoted") &&
 229        expr "$head" : "$_x40\$" >/dev/null ||
 230                die "Failed to fetch $remote_name from $remote"
 231        echo >&2 Fetching "$remote_name from $remote" using http
 232        git-http-fetch -v -a "$head" "$remote/" || exit
 233        ;;
 234    rsync://*)
 235        TMP_HEAD="$GIT_DIR/TMP_HEAD"
 236        rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
 237        head=$(git-rev-parse --verify TMP_HEAD)
 238        rm -f "$TMP_HEAD"
 239        test "$rsync_slurped_objects" || {
 240            rsync -av --ignore-existing --exclude info \
 241                "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
 242
 243            # Look at objects/info/alternates for rsync -- http will
 244            # support it natively and git native ones will do it on the remote
 245            # end.  Not having that file is not a crime.
 246            rsync -q "$remote/objects/info/alternates" \
 247                "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 248                rm -f "$GIT_DIR/TMP_ALT"
 249            if test -f "$GIT_DIR/TMP_ALT"
 250            then
 251                resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
 252                while read alt
 253                do
 254                    case "$alt" in 'bad alternate: '*) die "$alt";; esac
 255                    echo >&2 "Getting alternate: $alt"
 256                    rsync -av --ignore-existing --exclude info \
 257                    "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
 258                done
 259                rm -f "$GIT_DIR/TMP_ALT"
 260            fi
 261            rsync_slurped_objects=t
 262        }
 263        ;;
 264    *)
 265        # We will do git native transport with just one call later.
 266        continue ;;
 267    esac
 268
 269    append_fetch_head "$head" "$remote" \
 270        "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 271
 272done
 273
 274case "$remote" in
 275http://* | https://* | rsync://* )
 276    ;; # we are already done.
 277*)
 278    IFS="       $LF"
 279    (
 280        git-fetch-pack "$remote" $rref || echo failed "$remote"
 281    ) |
 282    while read sha1 remote_name
 283    do
 284        case "$sha1" in
 285        failed)
 286                echo >&2 "Fetch failure: $remote"
 287                exit 1 ;;
 288        esac
 289        found=
 290        single_force=
 291        for ref in $refs
 292        do
 293            case "$ref" in
 294            +$remote_name:*)
 295                single_force=t
 296                not_for_merge=
 297                found="$ref"
 298                break ;;
 299            .+$remote_name:*)
 300                single_force=t
 301                not_for_merge=t
 302                found="$ref"
 303                break ;;
 304            .$remote_name:*)
 305                not_for_merge=t
 306                found="$ref"
 307                break ;;
 308            $remote_name:*)
 309                not_for_merge=
 310                found="$ref"
 311                break ;;
 312            esac
 313        done
 314        local_name=$(expr "$found" : '[^:]*:\(.*\)')
 315        append_fetch_head "$sha1" "$remote" \
 316                "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 317    done || exit
 318    ;;
 319esac
 320
 321# If the original head was empty (i.e. no "master" yet), or
 322# if we were told not to worry, we do not have to check.
 323case ",$update_head_ok,$orig_head," in
 324*,, | t,* )
 325        ;;
 326*)
 327        curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 328        if test "$curr_head" != "$orig_head"
 329        then
 330                git-update-ref HEAD "$orig_head"
 331                die "Cannot fetch into the current branch."
 332        fi
 333        ;;
 334esac